Bug 475814 - race in aio_complete() leads to process hang
race in aio_complete() leads to process hang
Status: CLOSED ERRATA
Product: Red Hat Enterprise Linux 5
Classification: Red Hat
Component: kernel (Show other bugs)
5.4
All Linux
urgent Severity urgent
: rc
: ---
Assigned To: Jeff Moyer
Red Hat Kernel QE team
: ZStream
: 456687 (view as bug list)
Depends On: 456686
Blocks: 638868
  Show dependency treegraph
 
Reported: 2008-12-10 11:16 EST by Jeff Moyer
Modified: 2010-09-30 03:48 EDT (History)
7 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2009-09-02 04:48:25 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Jeff Moyer 2008-12-10 11:16:28 EST
+++ This bug was initially created as a clone of Bug #456686 +++

Description of problem:
There is a missing memory barrier in the current aio_complete in the RHEL4
kernels causing a race between read_events/aio_complete causing the thread in
read_events to sleep indefinitely, hanging the application that is waiting on
I/O completion.

This was reported upstream by Quentin Barnes of Yahoo:

http://lkml.org/lkml/2008/3/12/207

Fix has been merged in 2.6.26:

http://git.kernel.org/?p=linux/kernel/git/torvalds/linux-2.6.git;a=commit;h=6cb2a21049b8990df4576c5fce4d48d0206c22d5

And was also accepted for 2.6.24.y:

http://git.kernel.org/?p=linux/kernel/git/stable/linux-2.6.24.y.git;a=commit;h=0db49fc729eee503836ea12745b55f7f802d2abb

Version-Release number of selected component (if applicable):


How reproducible:
Unclear. Depends on the AIO application; Quentin reports seeing hangs virtually
100% of the time. Looking for a straightforward reproducer for this now and will
update with details when they are available.

Steps to Reproduce:
< to be filled >
  
Actual results:
Application hangs in read_events

Expected results:
No hang. AIO completes as normal.

Additional info:

--- Additional comment from pm-rhel@redhat.com on 2008-09-03 09:12:05 EDT ---

Updating PM score.

--- Additional comment from pm-rhel@redhat.com on 2008-09-22 13:53:39 EDT ---

This request was evaluated by Red Hat Product Management for inclusion in a Red
Hat Enterprise Linux maintenance release.  Product Management has requested
further review of this request by Red Hat Engineering, for potential
inclusion in a Red Hat Enterprise Linux Update release for currently deployed
products.  This request is not yet committed for inclusion in an Update
release.
Comment 1 RHEL Product and Program Management 2009-01-27 15:42:53 EST
This request was evaluated by Red Hat Product Management for inclusion in a Red
Hat Enterprise Linux maintenance release.  Product Management has requested
further review of this request by Red Hat Engineering, for potential
inclusion in a Red Hat Enterprise Linux Update release for currently deployed
products.  This request is not yet committed for inclusion in an Update
release.
Comment 2 Jeff Moyer 2009-02-13 10:56:25 EST
*** Bug 456687 has been marked as a duplicate of this bug. ***
Comment 3 RHEL Product and Program Management 2009-02-16 10:31:46 EST
Updating PM score.
Comment 5 Don Zickus 2009-04-27 11:58:38 EDT
in kernel-2.6.18-141.el5
You can download this test kernel from http://people.redhat.com/dzickus/el5

Please do NOT transition this bugzilla state to VERIFIED until our QE team
has sent specific instructions indicating when to do so.  However feel free
to provide a comment indicating that this fix has been verified.
Comment 7 Chris Ward 2009-07-03 14:17:36 EDT
~~ Attention - RHEL 5.4 Beta Released! ~~

RHEL 5.4 Beta has been released! There should be a fix present in the Beta release that addresses this particular request. Please test and report back results here, at your earliest convenience. RHEL 5.4 General Availability release is just around the corner!

If you encounter any issues while testing Beta, please describe the issues you have encountered and set the bug into NEED_INFO. If you encounter new issues, please clone this bug to open a new issue and request it be reviewed for inclusion in RHEL 5.4 or a later update, if it is not of urgent severity.

Please do not flip the bug status to VERIFIED. Only post your verification results, and if available, update Verified field with the appropriate value.

Questions can be posted to this bug or your customer or partner representative.
Comment 9 errata-xmlrpc 2009-09-02 04:48:25 EDT
An advisory has been issued which should help the problem
described in this bug report. This report is therefore being
closed with a resolution of ERRATA. For more information
on therefore solution and/or where to find the updated files,
please follow the link below. You may reopen this bug report
if the solution does not work for you.

http://rhn.redhat.com/errata/RHSA-2009-1243.html

Note You need to log in before you can comment on or make changes to this bug.